/**
 * API Type Definition
 */
/**
 * Client to Server message
 */
export declare type ClientToServerSender = (message: ClientToServerMessageTypes) => void;
export declare type ClientToServerMessageTypes = CreateIndexMessage;
export declare enum WebSocketClientToServerMessageType {
    createIndex = "createIndex"
}
export interface CreateIndexMessage {
    type: WebSocketClientToServerMessageType.createIndex;
    fileGlob: string[];
}
/**
 * Server to Client message
 */
export declare type ServerToClientSender = (message: ServerToClientMessageTypes) => void;
export declare type ServerToClientMessageTypes =
    | ServerToClientErrorMessage
    | ServerToClientIndexProgressMessage
    | ServerToClientConnectedMessage
    | ServerToClientCompleteIndexMessage;
export declare enum WebSocketServerToClientMessageType {
    connected = "connected",
    error = "error",
    progress = "create-index-progress",
    completeIndexing = "complete-indexing"
}
export interface ServerToClientConnectedMessage {
    type: WebSocketServerToClientMessageType.connected;
}
export interface ServerToClientErrorMessage {
    type: WebSocketServerToClientMessageType.error;
    message: string;
}
export interface ServerToClientIndexProgressMessage {
    type: WebSocketServerToClientMessageType.progress;
    progress: number;
}
export interface ServerToClientCompleteIndexMessage {
    type: WebSocketServerToClientMessageType.completeIndexing;
}
